#include "interrupts.h"
#include "string.h"
#include "task.h"

u16 fork(void)
{
	cli();
	struct task *child = create_task(current_task->uid);
	if (!child)
		return -1;
	child->daddy = current_task;
	current_task->child = child;
	memcpy(child->esp0, current_task->esp0, STACK_SIZE);
	toris();
	return current_task == child ? 0 : child->uid;
}
